import React from 'react';
import { ErrorBoundaryPropsWithComponent, ErrorBoundaryPropsWithFallback, ErrorBoundaryPropsWithRender, FallbackProps } from 'react-error-boundary';
declare let DefaultFallback: (props: FallbackProps) => JSX.Element;
/**
 * @see https://www.npmjs.com/package/react-error-boundary
 */
declare type MakePartial<T, K extends keyof T> = Omit<T, K> & Partial<Pick<T, K>>;
declare type ErrorBoundaryProps = ErrorBoundaryPropsWithFallback | ErrorBoundaryPropsWithRender | MakePartial<ErrorBoundaryPropsWithComponent, 'FallbackComponent'>;
declare type CustomErrorBoundaryProps = {
    log?: boolean;
    allowDevErrorOverlay?: boolean;
};
export declare const ErrorBoundary: React.FC<ErrorBoundaryProps & CustomErrorBoundaryProps>;
export declare function setDefaultErrorBoundaryFallback(component: typeof DefaultFallback): void;
export {};
